#include <ESP8266WiFi.h>
#include <ESP8266WiFiMulti.h>
#include <ESP8266HTTPClient.h>
#include <ArduinoJson.h>
#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
  #include <avr/power.h>
#endif

#define PIN            2
#define NUMPIXELS      60

Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

ESP8266WiFiMulti WiFiMulti;

void setup() {
    Serial.begin(115200);
    delay(10);
    WiFi.mode(WIFI_STA);

    WiFiMulti.addAP("redx", "1234567890x");

    Serial.print("Wait for WiFi... ");

    while(WiFiMulti.run() != WL_CONNECTED) {
        Serial.print(".");
        delay(500);
    }
    pixels.setBrightness(70);
    pixels.begin();

    delay(500);
}

const size_t capacity = 128*JSON_ARRAY_SIZE(3) + 3*JSON_ARRAY_SIZE(128) + JSON_OBJECT_SIZE(1);
DynamicJsonDocument doc(capacity);

int r,g,b;
int col;
void loop() {
         
      if (WiFi.status() == WL_CONNECTED && col < NUMPIXELS) {
       
         for( int x = 0; x < NUMPIXELS; x++ ){ pixels.setPixelColor(x, 200,200,200); }
         pixels.show();
         delay(500);
         for( int x = 0; x < NUMPIXELS; x++ ){ pixels.setPixelColor(x, 0,0,0); }
         pixels.show();
         delay(3000);
         
        for ( col = 0; col < 60; col++ ){
          
          HTTPClient http;  
          http.begin("http://192.168.43.177:5000/next/" + String(col) );
          int httpCode = http.GET();
          if (httpCode > 0) {
            String payload = http.getString();
           
            deserializeJson(doc, payload);
            JsonObject obj = doc.as<JsonObject>();
            
            for( int x = 0; x < NUMPIXELS; x++ ){
                
                  b = obj["data"][x][0].as<int>();
                  g = obj["data"][x][1].as<int>();
                  r = obj["data"][x][2].as<int>();
//                  Serial.print(r); Serial.print(" "); Serial.print(g); Serial.print(" "); Serial.print(b);
//                  Serial.println();
////                  
                  pixels.setPixelColor(x+1, pixels.Color(r,g,b));

            }
            
            pixels.show();               
            delay(16);
            http.end();            
          }
        } 
      }
      else{  
         for( int x = 0; x < NUMPIXELS; x++ ){
           pixels.setPixelColor(x, 0,0,0); 
         }
         pixels.show();
         delay(1000);
      }

      
}

